;(function() {
	var version = '0.1.3',
		pluginName = 'framr';
	$.fn.framr = function(options, param) {
		var results = [];
		for(var i = 0; i < this.length; i++) {
			var self = $(this[i]);
			if(!self.data('instance') && typeof options != 'string') {
				var instance = new framr(self, options);
				self.data('instance', instance);
				instance.private_methods.initialise();
			} else {
				var instance = self.data('instance');
				if(!instance) {
					console.log('['+pluginName+' v'+version+'] - You\'re trying to fire a method on an element with no instance!');
					return false;
				} else if(instance.public_methods[options]) {
					if (this.length > 1) {
						results.push(instance.public_methods[options](param));
					} else {
						return instance.public_methods[options](param);
					}
				} else {
					instance.private_methods.error(options + ' is not a defined method! Here\'s a list of methods! https://github.com/WsCandy/zRS#methods');
				}
			}
		}
		return results;
	}
	function framr(self, options, param) {
		var instance = this;

		instance.defaults = {
			auto: false,
			trigger: 'framr',
			escapeClose: true,
			overlayClose: true,
			contentClose: false,
			overlayFade: 250,
			contentDelay: 250,
			contentFade: 250,
			beforeLoad: function(){},
			overlayComplete: function(){},
			contentComplete: function(){}
		}
		var settings = $.extend(instance.defaults, options);
		instance.private_methods = {
			initialise: function() {
				console.log('['+pluginName+' '+version+'] ');
				console.log(settings);
				if(settings.autoOpen === true) {
					var trigger = settings.trigger;
  					instance.private_methods.open(img,trigger);
	  				instance.public_methods.close();
				} else {
					$('.' + settings.trigger).click(function(e){
	  					e.preventDefault();
						var img = $(this).attr('href');
						var trigger = settings.trigger;
	  					instance.private_methods.open(img,trigger);
	  					instance.private_methods.close();
					});
				}
			},
			error: function(error) {
				console.log('['+pluginName+' '+version+'] - ' + error);
			},
			open: function(img,trigger) {
				console.log(trigger);
				$('<img class="framr_img" src="' + img + '">').load(settings.beforeLoad);
				$('body').append("<div class='framr_overlay' style='position: fixed;z-index: 990;background: #444;opacity: 0.7;top: 0px;right: 0px;	bottom: 0px;left: 0px;display: none;''></div>" + "<div class='framr_wrapper'><div class='framr_close'></div>" + "<img class='framr_img' src=" + img + ">" + "</div>");
				if (settings.overlayFade > settings.contentFade && settings.contentDelay == 0) {
					$('.framr_wrapper').stop(true,true).delay(settings.contentDelay).fadeIn(settings.overlayFade, settings.contentComplete);
					$('.framr_overlay').stop(true,true).fadeIn(settings.overlayFade, settings.overlayComplete);
				} else {
					$('.framr_wrapper').stop(true,true).delay(settings.contentDelay).fadeIn(settings.contentFade, settings.contentComplete);
					$('.framr_overlay').stop(true,true).fadeIn(settings.overlayFade, settings.overlayComplete);
				}
			},
			close: function() {
				if (settings.overlayClose == true) {
					$('.framr_overlay').click(function(){
						$(this).fadeOut(function(){
							$(this).remove();
						});
						$( ".framr_wrapper").fadeOut(function(){
							$(this).remove();
						});
					});
				}

				if (settings.escapeClose == true) {
					$(document).keyup(function(e) {
						if (e.keyCode == 27) {
							$('.framr_overlay').fadeOut(function(){
								$(this).remove();
							});
							$( ".framr_wrapper").fadeOut(function(){
								$(this).remove();
							});
						}
					});
				}
				if (settings.contentClose == true) {
					$('.framr_wrapper').click(function(){
						$('.framr_overlay').fadeOut(function(){
							$(this).remove();
						});
						$(this).fadeOut(function(){
							$(this).remove();
						});
					});
				}
				$('.framr_close').click(function(){
					$('.framr_overlay').fadeOut(function(){
						$(this).remove();
					});
					$( ".framr_wrapper").fadeOut(function(){
						$(this).remove();
					});
				});
			}
		}

		instance.public_methods = {
			public: function(param) {
				console.log('Public method fired! ' + (param ? param : ''));
			},
			close: function() {
				$('.framr_overlay').fadeOut(function(){
					$(this).remove();
				});
				$( ".framr_wrapper" ).fadeOut(function(){
					$(this).remove();
				});
			}
		}
	}
})();